<!DOCTYPE html>
<html lang="es">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Capitulo_3</title>
</head>
<body>
    <h1>Capitulo 4</h1>
    <a>Ejercicio 6</a>

    <script>

        class Node {
            constructor(data) {
                this.data = data;
                this.left = null;
                this.right = null;
                this.parent = null 
            }
        }
            
        function proximoNodo(root, n) {
                if( n.right != null ) {
                    return minValue(n.right);
                }

                let succ = null;

                while (root != null) {
                    if (n.data < root.data) {
                        succ = root;
                        root = root.right;
                    } else if ( n.data > root.data ) {
                        root = root.right;
                    } else {
                        break;
                    }
                }
                return succ;
            }

        function minValue(node) {
                let current = node;

                while (current.left != null) {
                    current = current.left;
                }
                return current;
            }

        function insertar(node, data) {
                if (node === null) {
                    return (new Node(data));
                } else {
                    let temp;

                    if (data <= node.data) {
                        temp = insertar(node.left, data);
                        node.left = temp;
                        temp.parent = node;
                    } else {
                        temp = insertar(node.right, data); 
                        node.right = temp;
                        temp.parent = node;
                    }
                    return node;
                }
            }
        

        let root = null, temp, succ, min;
        root = insertar(root, 20);
        root = insertar(root, 8);
        root = insertar(root, 22);
        root = insertar(root, 4);
        root = insertar(root, 12);
        root = insertar(root, 10);
        root = insertar(root, 14);
        temp = root.left.right.right;

        succ = proximoNodo(root,temp);
        if (succ != null) {
            console.log(`El Proximo nodo: "${temp.data}"`);
        } else {
            console.log("No existe un nodo");
        }
        
    </script>
    
</body>
</html>